diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/lib/quagga/src/quagga.c olsrd-current/lib/quagga/src/quagga.c
--- olsrd-0.5.3/lib/quagga/src/quagga.c	2007-03-12 00:26:06.000000000 +0100
+++ olsrd-current/lib/quagga/src/quagga.c	2007-08-25 21:48:42.000000000 +0200
@@ -46,9 +46,11 @@
 #define BUFSIZE 1024
 
 #define STATUS_CONNECTED 1
+#define OPTION_EXPORT 1
 
 static struct {
-  char status; // TODO: internal status
+  char status; // internal status
+  char options; // internal options
   int sock; // Socket to zebra...
   char redistribute[ZEBRA_ROUTE_MAX];
   char distance;
@@ -58,22 +60,21 @@
 
 
 /* prototypes intern */
-static char *try_read (ssize_t *);
-static char* zebra_route_packet (struct ipv4_route r, ssize_t *);
-static int parse_interface_add (char *, size_t);
-static int parse_interface_delete (char *, size_t);
-static int parse_interface_up (char *, size_t);
-static int parse_interface_down (char *, size_t);
-static int parse_interface_address_add (char *, size_t);
-static int parse_interface_address_delete (char *, size_t);
-static int parse_ipv4_route (char *, size_t, struct ipv4_route *);
-static int ipv4_route_add (char *, size_t);
-static int ipv4_route_delete (char *, size_t);
-static int parse_ipv6_route_add (char*, size_t);
-static int zebra_reconnect (void);
-static int zebra_connect (void);
-static int add_v4_route_status (struct ipv4_route r);
-static int del_v4_route_status (struct ipv4_route r);
+static unsigned char *try_read (ssize_t *);
+static unsigned char* zebra_route_packet (struct ipv4_route r, ssize_t *);
+static int parse_interface_add (unsigned char *, size_t);
+static int parse_interface_delete (unsigned char *, size_t);
+static int parse_interface_up (unsigned char *, size_t);
+static int parse_interface_down (unsigned char *, size_t);
+static int parse_interface_address_add (unsigned char *, size_t);
+static int parse_interface_address_delete (unsigned char *, size_t);
+static int parse_ipv4_route (unsigned char *, size_t, struct ipv4_route *);
+static int ipv4_route_add (unsigned char *, size_t);
+static int ipv4_route_delete (unsigned char *, size_t);
+static int parse_ipv6_route_add (unsigned char*, size_t);
+static void zebra_reconnect (void);
+static void zebra_connect (void);
+
 static uint32_t prefixlentomask (uint8_t);
 static void free_ipv4_route (struct ipv4_route);
 static void update_olsr_zebra_routes (struct ipv4_route*, struct ipv4_route*);
@@ -85,7 +86,6 @@
 static uint8_t masktoprefixlen (uint32_t);
 
 
-
 #ifdef MY_DEBUG
 static void dump_ipv4_route (struct ipv4_route r, char *c) {
   int i = 0, x = 0;
@@ -147,114 +147,72 @@
 void *my_realloc (void *buf, size_t s, const char *c) {
   buf = realloc (buf, s);
   if (!buf) {
-    OLSR_PRINTF (1, "OUT OF MEMORY: %s\n", strerror(errno));
+    OLSR_PRINTF (1, "(QUAGGA) OUT OF MEMORY: %s\n", strerror(errno));
     olsr_syslog(OLSR_LOG_ERR, "olsrd: out of memory!: %m\n");
     olsr_exit(c, EXIT_FAILURE);
   }
   return buf;
 }
 
-int init_zebra () {
-  if (zebra_connect() < 0 || !(zebra.status&STATUS_CONNECTED)) {
-    olsr_exit ("AIIIII, could not connect to zebra! is zebra running?", 
+void init_zebra (void) {
+  zebra_connect();
+  if (!zebra.status&STATUS_CONNECTED)
+    olsr_exit ("(QUAGGA) AIIIII, could not connect to zebra! is zebra running?", 
 	       EXIT_FAILURE);
-  }
 }
 
-
-static int zebra_reconnect (void) {
-  struct ipv4_route *tmp;
+void zebra_cleanup (void) {
   int i;
+  struct rt_entry *tmp;
+  if (zebra.options & OPTION_EXPORT) {
+    for (i = 0; i < HASHSIZE; i++) {
+      for (tmp = routingtable[i].next; tmp != &routingtable[i]; tmp = tmp->next)
+	zebra_del_olsr_v4_route (tmp);     
+      for (tmp = hna_routes[i].next; tmp != &hna_routes[i]; tmp = tmp->next)
+	zebra_del_olsr_v4_route (tmp) ;   }
+  }  
 
-  if (zebra_connect() < 0 || !(zebra.status&STATUS_CONNECTED)) 
-    // log: zebra-reconnect failed
-    ;
   for (i = 0; ZEBRA_ROUTE_MAX - 1; i++)
-    if (zebra.redistribute[i]) zebra_redistribute(i + 1);
-
-  for (tmp = zebra.v4_rt; tmp; tmp = tmp->next)
-    zebra_add_v4_route(*tmp);
-}
-
-
-static int add_v4_route_status (struct ipv4_route r) {
-
-  struct ipv4_route *tmp = olsr_malloc (sizeof r, "quagga_v4_route_status");
-  memcpy (tmp, &r, sizeof r);
-
-  if (r.message & ZAPI_MESSAGE_NEXTHOP) {
-    tmp->nexthops = olsr_malloc (r.nh_count * sizeof tmp->nexthops, 
-				 "quagga_v4_route_status");
-    memcpy (tmp->nexthops, &r.nexthops, sizeof *r.nexthops);
-  }
-
-  if (r.message & ZAPI_MESSAGE_IFINDEX) {
-    tmp->index = olsr_malloc (r.ind_num * sizeof *tmp->index, 
-			      "quagga_v4_route_status");
-    memcpy (tmp->index, &r.index, r.ind_num * sizeof *tmp->index);
-  }
-
-  tmp->next = zebra.v4_rt;
-  zebra.v4_rt = tmp;
-
-  return 0;
-
-}
-
-
-static int cmp_v4_route (struct ipv4_route a, struct ipv4_route b) {
-  if (a.type != b.type) return 1;
-  if (a.flags != b.flags) return 1;
-  if (a.message != b.message) return 1;
-  if (a.prefixlen != b.prefixlen) return 1;
-  if (a.message & ZAPI_MESSAGE_NEXTHOP) {
-    if (a.nh_count != b.nh_count) return 1;
-    if (memcmp (a.nexthops, b.nexthops, a.nh_count * sizeof *b.nexthops)) 
-      return 1;
-  }
-  if (a.message & ZAPI_MESSAGE_IFINDEX) {
-    if (a.ind_num != b.ind_num) return 1;
-    if (memcpy (a.index, b.index, a.ind_num * sizeof *a.index)) return 1;
-  }
-  if (a.message & ZAPI_MESSAGE_DISTANCE) 
-    if (a.distance != b.distance) return 1;
-  if (a.message & ZAPI_MESSAGE_METRIC)
-    if (a.metric != b.metric) return 1;
-  return 0;
+    if (zebra.redistribute[i]) zebra_disable_redistribute(i + 1);
 }
 
-static int del_v4_route_status (struct ipv4_route r) {
 
-  struct ipv4_route *tmp, *prv = 0;
-
-  for (tmp = zebra.v4_rt; tmp; tmp = tmp->next) {
-    if (!cmp_v4_route(*tmp, r)) {
-      if (prv) prv->next = tmp->next;
-
-      free_ipv4_route(*tmp);
-      free (tmp);
+static void zebra_reconnect (void) {
+  struct rt_entry *tmp;
+  int i;
 
-      return 0;
+  zebra_connect();
+  if (!zebra.status & STATUS_CONNECTED) return; // try again next time
 
+  if (zebra.options & OPTION_EXPORT) {
+    for (i = 0; i < HASHSIZE; i++) {
+      for (tmp = routingtable[i].next; tmp != &routingtable[i]; tmp = tmp->next)
+	zebra_add_olsr_v4_route (tmp);     
+      for (tmp = hna_routes[i].next; tmp != &hna_routes[i]; tmp = tmp->next)
+	zebra_add_olsr_v4_route (tmp);
     }
-    prv = tmp;
-  }
+  }  
 
-  return 1;
+  for (i = 0; ZEBRA_ROUTE_MAX - 1; i++)
+    if (zebra.redistribute[i]) zebra_redistribute(i + 1);
+  /* Zebra sends us all routes of type it knows after 
+     zebra_redistribute(type) */
 }
 
 
+
 /* Connect to the zebra-daemon, returns a socket */
-static int zebra_connect (void) {
+static void zebra_connect (void) {
 
 #ifndef USE_UNIX_DOMAIN_SOCKET
   struct sockaddr_in i;
-  close (zebra.sock);
+  if (close (zebra.sock) < 0) olsr_exit ("(QUAGGA) Could not close socket!", EXIT_FAILURE);
+  
 
   zebra.sock = socket (AF_INET,SOCK_STREAM, 0);
 #else
   struct sockaddr_un i;
-  close (zebra.sock);
+  if (close (zebra.sock) < 0) olsr_exit ("(QUAGGA) Could not close socket!", EXIT_FAILURE);
 
   zebra.sock = socket (AF_UNIX,SOCK_STREAM, 0);
 #endif
@@ -262,7 +220,7 @@
   int ret;
 
   if (zebra.sock <0 )
-    olsr_exit("could not create socket!", EXIT_FAILURE);
+    olsr_exit("(QUAGGA) Could not create socket!", EXIT_FAILURE);
   
   memset (&i, 0, sizeof i);
 #ifndef USE_UNIX_DOMAIN_SOCKET
@@ -275,18 +233,15 @@
 #endif
 
   ret = connect (zebra.sock, (struct sockaddr *)&i, sizeof i);
-  if  (ret < 0) {
-    close (zebra.sock);
-  }
+  if  (ret < 0) zebra.status &= ~STATUS_CONNECTED;
   else zebra.status |= STATUS_CONNECTED;
-  return zebra.sock;
 }
 
     
 /* Sends a command to zebra, command is 
    the command defined in zebra.h, options is the packet-payload, 
    optlen the length, of the payload */
-char zebra_send_command (unsigned char command, char * options, int optlen) {
+unsigned char zebra_send_command (unsigned char command, unsigned char * options, int optlen) {
 
 #ifdef ZEBRA_HEADER_MARKER
   char *p = olsr_malloc (optlen + 6, "zebra_send_command");
@@ -297,10 +252,11 @@
   char *p = olsr_malloc (optlen + 3, "zebra_send_command");
   uint16_t length = optlen + 3;  // length of option + command + packet_length
 #endif
-  
+  char *pnt = p;
   int ret;
   
   uint16_t len = htons(length);
+
   memcpy (p, &len, 2);
 
 #ifdef ZEBRA_HEADER_MARKER
@@ -324,24 +280,26 @@
 	continue;
       }
       else {
+	olsr_printf (1, "(QUAGGA) Disconnected from zebra\n");
 	zebra.status &= ~STATUS_CONNECTED;
+	free (pnt);
 	return -1;
       }
     }
     p = p+ret;
   } while ((length -= ret));
-
+  free (pnt);
   return 0;
 }
 
 
 /* Creates a Route-Packet-Payload, needs address, netmask, nexthop, 
    distance, and a pointer of an size_t */
-static char* zebra_route_packet (struct ipv4_route r, ssize_t *optlen) {
+static unsigned char* zebra_route_packet (struct ipv4_route r, ssize_t *optlen) {
 
   int count;
 
-  char *cmdopt, *t;
+  unsigned char *cmdopt, *t;
   *optlen = 4; // first: type, flags, message, prefixlen
   *optlen += r.prefixlen / 8 + (r.prefixlen % 8 ? 1 : 0); // + prefix
   if (r.message & ZAPI_MESSAGE_NEXTHOP)
@@ -405,7 +363,7 @@
 /* adds a route to zebra-daemon */
 int zebra_add_v4_route (struct ipv4_route r) {
   
-  char *cmdopt;
+  unsigned char *cmdopt;
   ssize_t optlen;
   int retval;
 
@@ -420,7 +378,7 @@
 /* deletes a route from the zebra-daemon */
 int zebra_delete_v4_route (struct ipv4_route r) {
   
-  char *cmdopt;
+  unsigned char *cmdopt;
   ssize_t optlen;
   int retval;
 
@@ -436,20 +394,20 @@
 
 /* Check wether there is data from zebra aviable */
 void zebra_check (void* foo) {
-  char *data, *f;
+  unsigned char *data, *f;
   ssize_t len, ret;
 
   if (!(zebra.status & STATUS_CONNECTED)) {
-    if (!zebra_reconnect()) return;
+    zebra_reconnect();
+    return;
   }
   data = try_read (&len);
   if (data) {
     f = data;
     do {
       ret = zebra_parse_packet (f, len);
-      if (!ret) {//something wired happened
-	puts ("DEBUG: IIIIIIIIIIRGS");
-	exit (EXIT_FAILURE);
+      if (!ret) { // something wired happened
+	olsr_exit ("(QUAGGA) Zero message length??? ", EXIT_FAILURE);
       }
       f += ret;
     } while ((f - data) < len);
@@ -460,8 +418,8 @@
 
 // tries to read a packet from zebra_socket
 // if there is something to read - make sure to read whole packages
-static char *try_read (ssize_t *len) {
-  char *buf = NULL;
+static unsigned char *try_read (ssize_t *len) {
+  unsigned char *buf = NULL;
   ssize_t ret = 0, bsize = 0;
   uint16_t length = 0, l = 0;
   int sockstate;
@@ -477,22 +435,16 @@
       buf = my_realloc (buf, bsize, "Zebra try_read");
     }
     ret = read (zebra.sock, buf + l, bsize - l);
-    if (ret <= 0) {
-      if (errno == EAGAIN) {
-	errno = 0;
-      }
-      else {
-	olsr_printf(1, "OOPS, something realy wired happened:"
-		    "read returned %s\n", strerror(errno));
-	errno = 0;
-	zebra.status &= ~STATUS_CONNECTED;
-	return 0;
-      }
+    if (!ret) { // nothing more to read, packet is broken, discard!
       free (buf);
       return NULL;
     }
-    *len += ret;
+    if (ret < 0 && errno != EAGAIN) { // oops - we got disconnected
+      olsr_printf (1, "(QUAGGA) Disconnected from zebra\n");
+      zebra.status &= ~STATUS_CONNECTED;
+    }
 
+    *len += ret;
     while ((*len - l) > length) {
       l += length;
       memcpy (&length, buf + l, 2);
@@ -511,10 +463,13 @@
 
 
 /* Parse a packet recived from zebra */
-int zebra_parse_packet (char *packet, ssize_t maxlen) {
+int zebra_parse_packet (unsigned char *packet, ssize_t maxlen) {
+
+  uint16_t command;
+  int skip;
 
   /* Array of functions */
-  int (*foo[ZEBRA_MESSAGE_MAX]) (char *, size_t) = {
+  int (*foo[ZEBRA_MESSAGE_MAX]) (unsigned char *, size_t) = {
     parse_interface_add,
     parse_interface_delete,
     parse_interface_address_add,
@@ -526,67 +481,79 @@
     parse_ipv6_route_add
   };
 
+  uint16_t length;
+  int ret;
+
 #ifdef MY_DEBUG
   puts ("DEBUG: zebra_parse_packet");
 #endif
-  uint16_t length;
-  
-  int ret;
+
   memcpy (&length, packet, 2);
   length = ntohs (length);
   
   if (maxlen < length) {
-    puts("Error: programmer is an idiot");
-    printf ("DEBUG: maxlen = %d, packet_length = %d\n", maxlen, length);
-    return maxlen;
+    olsr_printf (1, "(QUAGGA) maxlen = %d, packet_length = %d\n", maxlen, length);
+    olsr_exit ("(QUAGGA) programmer is an idiot", EXIT_FAILURE);
   }
 
-  if (packet[2] - 1 < ZEBRA_MESSAGE_MAX && foo[packet[2] - 1]) { 
-    if (!(ret = foo[packet[2] - 1] (packet + 3, length - 3))) 
+#ifdef ZEBRA_HEADER_MARKER
+  if (packet[2] == 255) { // found header marker!!
+    //packet[3] == ZSERV_VERSION: FIXME: HANDLE THIS!
+    memcpy (command, packet + 4, sizeof command); // two bytes command now!
+    command-- = ntohs (command); 
+    skip = 6;
+  }
+#else
+  command = packet[2] - 1;
+  skip = 3;
+#endif
+
+  if (command < ZEBRA_MESSAGE_MAX && foo[command]) { 
+    if (!(ret = foo[command] (packet + skip, length - skip))) 
       return length;
-    else printf ("DEBUG: Parse error: %d\n", ret);
+    else olsr_printf (1, "(QUAGGA) Parse error: %d\n", ret);
   }
   else
-    printf ("Unknown packet type: %d\n", packet[2]);
+    olsr_printf (1, "(QUAGGA) Unknown packet type: %d\n", packet[2]);
 
-  puts ("Quagga: RECIVED PACKET FROM ZEBRA THAT I CAN'T PARSE");
+  olsr_printf (1, "(Quagga) RECIVED PACKET FROM ZEBRA THAT I CAN'T PARSE");
 
   return length;
 }
 
 
-static int parse_interface_add (char *opt, size_t len) {
+static int parse_interface_add (unsigned char *opt, size_t len) {
   //todo
   return 0;
 }
 
 
-static int parse_interface_delete (char *opt, size_t len) {
+static int parse_interface_delete (unsigned char *opt, size_t len) {
   //todo
   return 0;
 }
 
 
-static int parse_interface_address_add (char *opt, size_t len) {
+static int parse_interface_address_add (unsigned char *opt, size_t len) {
   
   //todo
   return 0;
 }
 
-static int parse_interface_up (char *opt, size_t len) {
+static int parse_interface_up (unsigned char *opt, size_t len) {
   
   //todo
   return 0;
 }
 
-static int parse_interface_down (char *opt, size_t len) {
+static int parse_interface_down (unsigned char *opt, size_t len) {
   
   //todo
   return 0;
 }
 
 
-static int parse_interface_address_delete (char *opt, size_t  len) {
+static int parse_interface_address_delete (unsigned char *opt, size_t  len) {
   //todo
   return 0;
 }
@@ -594,7 +561,7 @@
 
 /* Parse an ipv4-route-packet recived from zebra
  */
-static int parse_ipv4_route (char *opt, size_t len, struct ipv4_route *r) {
+static int parse_ipv4_route (unsigned char *opt, size_t len, struct ipv4_route *r) {
   int c;
 
   if (len < 4) return -1;
@@ -653,22 +620,18 @@
 }
 
 
-static int ipv4_route_add (char *opt, size_t len) {
+static int ipv4_route_add (unsigned char *opt, size_t len) {
 
   struct ipv4_route r;
   int f;
     
   f = parse_ipv4_route (opt, len, &r);
-  if (f < 0) {
-    printf ("parse-error: %d\n",f);
-    return f;
-  }
-  
-  add_hna4_route (r);
-  return 0;
+  if (f < 0) return f;
+
+  return add_hna4_route (r);
 }
 
-static int ipv4_route_delete (char *opt, size_t len) {
+static int ipv4_route_delete (unsigned char *opt, size_t len) {
   struct ipv4_route r;
   int f;
   
@@ -679,7 +642,7 @@
   
 }
 
-static int parse_ipv6_route_add (char *opt, size_t len) {
+static int parse_ipv6_route_add (unsigned char *opt, size_t len) {
   //todo
   return 0;
 }
@@ -810,7 +773,6 @@
     route.distance = zebra.distance;
   }
 
-  add_v4_route_status (route);
   retval = zebra_add_v4_route(route);
   free_ipv4_route (route);
   return retval;
@@ -855,7 +817,6 @@
     route.distance = zebra.distance;
   }
 
-  retval = zebra_delete_v4_route(route);
   del_v4_route_status(route);
   free_ipv4_route (route);
   return retval;
@@ -868,3 +829,10 @@
 void zebra_olsr_localpref (void) {
   zebra.flags &= ZEBRA_FLAG_SELECTED;
 }
+
+void zebra_export (char t) {
+  if (t)
+    zebra.options |= OPTION_EXPORT;
+  else
+    zebra.options &= ~OPTION_EXPORT;
+}
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/lib/quagga/src/quagga.h olsrd-current/lib/quagga/src/quagga.h
--- olsrd-0.5.3/lib/quagga/src/quagga.h	2007-03-12 00:26:06.000000000 +0100
+++ olsrd-current/lib/quagga/src/quagga.h	2007-08-25 21:48:42.000000000 +0200
@@ -51,12 +51,13 @@
   struct ipv4_route *next;
 };
 
-int init_zebra (void);
-char zebra_send_command (unsigned char, char *, int );
+void init_zebra (void);
+void zebra_cleanup (void);
+unsigned char zebra_send_command (unsigned char, unsigned char *, int );
 int zebra_add_v4_route (struct ipv4_route r);
 int zebra_delete_v4_route (struct ipv4_route r);
 void zebra_check (void*);
-int zebra_parse_packet (char*, ssize_t);
+int zebra_parse_packet (unsigned char*, ssize_t);
 int zebra_redistribute (unsigned char);
 int zebra_disable_redistribute (unsigned char);
 int add_hna4_route (struct ipv4_route);
@@ -64,5 +65,6 @@
 void *my_realloc (void *, size_t, const char*);
 int zebra_add_olsr_v4_route (struct rt_entry*);
 int zebra_del_olsr_v4_route (struct rt_entry*);
-void zebra_olsr_localpref(void);
-void zebra_olsr_distance(char);
+void zebra_olsr_localpref (void);
+void zebra_olsr_distance (char);
+void zebra_export_routes (unsigned char);
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/lib/secure/src/olsrd_plugin.c olsrd-current/lib/secure/src/olsrd_plugin.c
--- olsrd-0.5.3/lib/secure/src/olsrd_plugin.c	2007-07-15 23:47:17.000000000 +0200
+++ olsrd-current/lib/secure/src/olsrd_plugin.c	2007-08-25 21:48:42.000000000 +0200
@@ -33,7 +33,7 @@
  * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
  * POSSIBILITY OF SUCH DAMAGE.
  *
- * $Id: olsrd_plugin.c,v 1.13 2007/07/15 21:47:17 bernd67 Exp $
+ * $Id: olsrd_plugin.c,v 1.14 2007/08/25 19:48:42 bernd67 Exp $
  */
 
 
@@ -90,9 +90,10 @@
   secure_plugin_exit();
 }
 
-static int store_string(const char *value, void *data)
+static int store_string(const char *value, void *data, unsigned int addon)
 {
   char *str = data;
+  if (addon) {}
   snprintf(str, FILENAME_MAX+1, "%s", value);
   return 0;
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/lib/tas/src/http.c olsrd-current/lib/tas/src/http.c
--- olsrd-0.5.3/lib/tas/src/http.c	2005-11-10 20:50:42.000000000 +0100
+++ olsrd-current/lib/tas/src/http.c	2007-09-03 00:17:00.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: http.c,v 1.5 2005/11/10 19:50:42 kattemat Exp $
+ * $Id: http.c,v 1.6 2007/09/02 22:17:00 bernd67 Exp $
  */
 
 #include "link.h"
@@ -447,7 +447,7 @@
   getRandomBytes(cookieStruct.key, 16);
 }
 
-int httpSetAddress(const char *addrStr)
+int httpSetAddress(const char *addrStr, void *data __attribute__((unused)), unsigned int addon __attribute__((unused)))
 {
   if (parseIpAddr(&confAddr, addrStr) < 0)
   {
@@ -458,7 +458,7 @@
   return 0;
 }
 
-int httpSetPort(const char *portStr)
+int httpSetPort(const char *portStr, void *data __attribute__((unused)), unsigned int addon __attribute__((unused)))
 {
   unsigned int port;
 
@@ -479,7 +479,7 @@
   return 0;
 }
 
-int httpSetRootDir(const char *rootDir)
+int httpSetRootDir(const char *rootDir, void *data __attribute__((unused)), unsigned int addon __attribute__((unused)))
 {
   if (checkAbsPath(rootDir) < 0)
   {
@@ -491,7 +491,7 @@
   return 0;
 }
 
-int httpSetWorkDir(const char *workDir)
+int httpSetWorkDir(const char *workDir, void *data __attribute__((unused)), unsigned int addon __attribute__((unused)))
 {
   if (checkAbsPath(workDir) < 0)
   {
@@ -503,22 +503,25 @@
   return 0;
 }
 
-void httpSetIndexFile(const char *indexFile)
+int httpSetIndexFile(const char *indexFile, void *data __attribute__((unused)), unsigned int addon __attribute__((unused)))
 {
   confIndexFile = myStrdup(indexFile);
+  return 0;
 }
 
-void httpSetUser(const char *user)
+int httpSetUser(const char *user, void *data __attribute__((unused)), unsigned int addon __attribute__((unused)))
 {
   confUser = myStrdup(user);
+  return 0;
 }
 
-void httpSetPassword(const char *password)
+int httpSetPassword(const char *password, void *data __attribute__((unused)), unsigned int addon __attribute__((unused)))
 {
   confPassword = myStrdup(password);
+  return 0;
 }
 
-int httpSetSessTime(const char *timeStr)
+int httpSetSessTime(const char *timeStr, void *data __attribute__((unused)), unsigned int addon __attribute__((unused)))
 {
   unsigned int time;
 
@@ -539,12 +542,13 @@
   return 0;
 }
 
-void httpSetPubDir(const char *pubDir)
+int httpSetPubDir(const char *pubDir, void *data __attribute__((unused)), unsigned int addon __attribute__((unused)))
 {
   confPubDir = myStrdup(pubDir);
+  return 0;
 }
 
-int httpSetQuantum(const char *quantumStr)
+int httpSetQuantum(const char *quantumStr, void *data __attribute__((unused)), unsigned int addon __attribute__((unused)))
 {
   unsigned int quantum;
 
@@ -565,7 +569,7 @@
   return 0;
 }
 
-int httpSetMessTime(const char *timeStr)
+int httpSetMessTime(const char *timeStr, void *data __attribute__((unused)), unsigned int addon __attribute__((unused)))
 {
   unsigned int time;
 
@@ -586,7 +590,7 @@
   return 0;
 }
 
-int httpSetMessLimit(const char *limitStr)
+int httpSetMessLimit(const char *limitStr, void *data __attribute__((unused)), unsigned int addon __attribute__((unused)))
 {
   unsigned int limit;
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/lib/tas/src/http.h olsrd-current/lib/tas/src/http.h
--- olsrd-0.5.3/lib/tas/src/http.h	2005-04-12 19:17:26.000000000 +0200
+++ olsrd-current/lib/tas/src/http.h	2007-09-03 00:17:00.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: http.h,v 1.1 2005/04/12 17:17:26 tlopatic Exp $
+ * $Id: http.h,v 1.2 2007/09/02 22:17:00 bernd67 Exp $
  */
 
 #define CHUNK_SIZE 1024
@@ -117,18 +117,18 @@
 
 extern void httpInit(void);
 
-extern int httpSetAddress(const char *addrStr);
-extern int httpSetPort(const char *portStr);
-extern int httpSetRootDir(const char *rootDir);
-extern int httpSetWorkDir(const char *workDir);
-extern void httpSetIndexFile(const char *indexFile);
-extern void httpSetUser(const char *user);
-extern void httpSetPassword(const char *password);
-extern int httpSetSessTime(const char *timeStr);
-extern void httpSetPubDir(const char *pref);
-extern int httpSetQuantum(const char *quantumStr);
-extern int httpSetMessTime(const char *timeStr);
-extern int httpSetMessLimit(const char *limitStr);
+extern int httpSetAddress(const char *addrStr, void *data, unsigned int addon);
+extern int httpSetPort(const char *portStr, void *data, unsigned int addon);
+extern int httpSetRootDir(const char *rootDir, void *data, unsigned int addon);
+extern int httpSetWorkDir(const char *workDir, void *data, unsigned int addon);
+extern int httpSetIndexFile(const char *indexFile, void *data, unsigned int addon);
+extern int httpSetUser(const char *user, void *data, unsigned int addon);
+extern int httpSetPassword(const char *password, void *data, unsigned int addon);
+extern int httpSetSessTime(const char *timeStr, void *data, unsigned int addon);
+extern int httpSetPubDir(const char *pref, void *data, unsigned int addon);
+extern int httpSetQuantum(const char *quantumStr, void *data, unsigned int addon);
+extern int httpSetMessTime(const char *timeStr, void *data, unsigned int addon);
+extern int httpSetMessLimit(const char *limitStr, void *data, unsigned int addon);
 
 extern int httpSetup(void);
 extern int httpService(int freq);
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/lib/tas/src/plugin.c olsrd-current/lib/tas/src/plugin.c
--- olsrd-0.5.3/lib/tas/src/plugin.c	2007-04-20 15:46:03.000000000 +0200
+++ olsrd-current/lib/tas/src/plugin.c	2007-09-03 00:17:00.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: plugin.c,v 1.8 2007/04/20 13:46:03 bernd67 Exp $
+ * $Id: plugin.c,v 1.9 2007/09/02 22:17:00 bernd67 Exp $
  */
 
 #include <string.h>
@@ -50,6 +50,7 @@
 #include "http.h"
 #include "glua.h"
 #include "glua_ext.h"
+#include "olsrd_plugin.h"
 
 #include <defs.h>
 #include <olsr.h>
@@ -67,6 +68,8 @@
 #include <mpr_selector_set.h>
 #include <duplicate_set.h>
 
+#define PLUGIN_INTERFACE_VERSION 5
+
 #define MESSAGE_TYPE 129
 
 int olsrd_plugin_interface_version(void);
@@ -462,7 +465,7 @@
 
 int olsrd_plugin_interface_version(void)
 {
-  return 4;
+  return PLUGIN_INTERFACE_VERSION;
 }
 
 int olsrd_plugin_init(void)
@@ -486,95 +489,23 @@
   return 0;
 }
 
-int olsrd_plugin_register_param(char *name, char *value)
-{
-  if (strcmp(name, "address") == 0)
-  {
-    if (httpSetAddress(value) < 0)
-      return 0;
-
-    return 1;
-  }
-
-  if (strcmp(name, "port") == 0)
-  {
-    if (httpSetPort(value) < 0)
-      return 0;
-
-    return 1;
-  }
-
-  if (strcmp(name, "rootdir") == 0)
-  {
-    if (httpSetRootDir(value) < 0)
-      return 0;
-
-    return 1;
-  }
-
-  if (strcmp(name, "workdir") == 0)
-  {
-    if (httpSetWorkDir(value) < 0)
-      return 0;
-
-    return 1;
-  }
-
-  if (strcmp(name, "indexfile") == 0)
-  {
-    httpSetIndexFile(value);
-    return 1;
-  }
-
-  if (strcmp(name, "user") == 0)
-  {
-    httpSetUser(value);
-    return 1;
-  }
+static const struct olsrd_plugin_parameters plugin_parameters[] = {
+    { .name = "address",   .set_plugin_parameter = &httpSetAddress,   .data = NULL },
+    { .name = "port",      .set_plugin_parameter = &httpSetPort,      .data = NULL },
+    { .name = "rootdir",   .set_plugin_parameter = &httpSetRootDir,   .data = NULL },
+    { .name = "workdir",   .set_plugin_parameter = &httpSetWorkDir,   .data = NULL },
+    { .name = "indexfile", .set_plugin_parameter = &httpSetIndexFile, .data = NULL },
+    { .name = "user",      .set_plugin_parameter = &httpSetUser,      .data = NULL },
+    { .name = "password",  .set_plugin_parameter = &httpSetPassword,  .data = NULL },
+    { .name = "sesstime",  .set_plugin_parameter = &httpSetSessTime,  .data = NULL },
+    { .name = "pubdir",    .set_plugin_parameter = &httpSetPubDir,    .data = NULL },
+    { .name = "quantum",   .set_plugin_parameter = &httpSetQuantum,   .data = NULL },
+    { .name = "messtime",  .set_plugin_parameter = &httpSetMessTime,  .data = NULL },
+    { .name = "messlimit", .set_plugin_parameter = &httpSetMessLimit, .data = NULL },
+};
 
-  if (strcmp(name, "password") == 0)
-  {
-    httpSetPassword(value);
-    return 1;
-  }
-
-  if (strcmp(name, "sesstime") == 0)
-  {
-    if (httpSetSessTime(value) < 0)
-      return 0;
-
-    return 1;
-  }
-
-  if (strcmp(name, "pubdir") == 0)
-  {
-    httpSetPubDir(value);
-    return 1;
-  }
-
-  if (strcmp(name, "quantum") == 0)
-  {
-    if (httpSetQuantum(value) < 0)
-      return 0;
-
-    return 1;
-  }
-
-  if (strcmp(name, "messtime") == 0)
-  {
-    if (httpSetMessTime(value) < 0)
-      return 0;
-
-    return 1;
-  }
-
-  if (strcmp(name, "messlimit") == 0)
-  {
-    if (httpSetMessLimit(value) < 0)
-      return 0;
-
-    return 1;
-  }
-
-  return 0;
+void olsrd_get_plugin_parameters(const struct olsrd_plugin_parameters **params, int *size)
+{
+    *params = plugin_parameters;
+    *size = sizeof(plugin_parameters)/sizeof(*plugin_parameters);
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/lib/tas/test.c olsrd-current/lib/tas/test.c
--- olsrd-0.5.3/lib/tas/test.c	2007-07-15 19:48:55.000000000 +0200
+++ olsrd-current/lib/tas/test.c	2007-09-03 00:17:00.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: test.c,v 1.2 2007/07/15 17:48:55 bernd67 Exp $
+ * $Id: test.c,v 1.3 2007/09/02 22:17:00 bernd67 Exp $
  */
 
 #include "src/link.h"
@@ -88,7 +88,7 @@
         return 1;
       }
 
-      if (httpSetAddress(av[i]) < 0)
+      if (httpSetAddress(av[i], NULL, 0) < 0)
       {
         fprintf(stderr, "cannot set address\n");
         return 1;
@@ -104,7 +104,7 @@
         return 1;
       }
 
-      if (httpSetPort(av[i]) < 0)
+      if (httpSetPort(av[i], NULL, 0) < 0)
       {
         fprintf(stderr, "cannot set port\n");
         return 1;
@@ -120,7 +120,7 @@
         return 1;
       }
 
-      if (httpSetWorkDir(av[i]) < 0)
+      if (httpSetWorkDir(av[i], NULL, 0) < 0)
       {
         fprintf(stderr, "cannot set work directory\n");
         return 1;
@@ -136,7 +136,7 @@
         return 1;
       }
 
-      if (httpSetRootDir(av[i]) < 0)
+      if (httpSetRootDir(av[i], NULL, 0) < 0)
       {
         fprintf(stderr, "cannot set root directory\n");
         return 1;
@@ -152,7 +152,7 @@
         return 1;
       }
 
-      httpSetIndexFile(av[i]);
+      httpSetIndexFile(av[i], NULL, 0);
     }
 
     else if (strcmp(av[i], "--user") == 0)
@@ -164,7 +164,7 @@
         return 1;
       }
 
-      httpSetUser(av[i]);
+      httpSetUser(av[i], NULL, 0);
     }
 
     else if (strcmp(av[i], "--password") == 0)
@@ -176,7 +176,7 @@
         return 1;
       }
 
-      httpSetPassword(av[i]);
+      httpSetPassword(av[i], NULL, 0);
     }
 
     else if (strcmp(av[i], "--sess-time") == 0)
@@ -188,7 +188,7 @@
         return 1;
       }
 
-      if (httpSetSessTime(av[i]) < 0)
+      if (httpSetSessTime(av[i], NULL, 0) < 0)
       {
         fprintf(stderr, "cannot set session timeout\n");
         return 1;
@@ -204,7 +204,7 @@
         return 1;
       }
 
-      httpSetPubDir(av[i]);
+      httpSetPubDir(av[i], NULL, 0);
     }
 
     else if (strcmp(av[i], "--quantum") == 0)
@@ -216,7 +216,7 @@
         return 1;
       }
 
-      if (httpSetQuantum(av[i]) < 0)
+      if (httpSetQuantum(av[i], NULL, 0) < 0)
       {
         fprintf(stderr, "cannot set quantum\n");
         return 1;
@@ -232,7 +232,7 @@
         return 1;
       }
 
-      if (httpSetMessTime(av[i]) < 0)
+      if (httpSetMessTime(av[i], NULL, 0) < 0)
       {
         fprintf(stderr, "cannot set message timeout\n");
         return 1;
@@ -248,7 +248,7 @@
         return 1;
       }
 
-      if (httpSetMessLimit(av[i]) < 0)
+      if (httpSetMessLimit(av[i], NULL, 0) < 0)
       {
         fprintf(stderr, "cannot set message queue limit\n");
         return 1;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/make/Makefile.fbsd olsrd-current/make/Makefile.fbsd
--- olsrd-0.5.3/make/Makefile.fbsd	2007-07-26 19:34:54.000000000 +0200
+++ olsrd-current/make/Makefile.fbsd	2007-08-29 23:46:25.000000000 +0200
@@ -37,6 +37,7 @@
 		/sbin/ldconfig
 
 OS_LIB_PTHREAD = -pthread
+OS_CFLAG_PTHREAD = -pthread
 OS_LIB_DYNLOAD =
 
 # Local Variables:
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/make/Makefile.linux olsrd-current/make/Makefile.linux
--- olsrd-0.5.3/make/Makefile.linux	2007-08-02 18:26:55.000000000 +0200
+++ olsrd-current/make/Makefile.linux	2007-08-29 23:46:25.000000000 +0200
@@ -29,6 +29,7 @@
 endif
 
 OS_LIB_PTHREAD = -lpthread
+OS_CFLAG_PTHREAD = -pthread
 OS_LIB_DYNLOAD = -ldl
 
 # Local Variables:
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/make/Makefile.nbsd olsrd-current/make/Makefile.nbsd
--- olsrd-0.5.3/make/Makefile.nbsd	2007-07-26 19:34:54.000000000 +0200
+++ olsrd-current/make/Makefile.nbsd	2007-08-29 23:46:25.000000000 +0200
@@ -21,6 +21,7 @@
 endif
 
 OS_LIB_PTHREAD = 
+OS_CFLAG_PTHREAD =
 OS_LIB_DYNLOAD =
 
 # Local Variables:
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/make/Makefile.obsd olsrd-current/make/Makefile.obsd
--- olsrd-0.5.3/make/Makefile.obsd	2007-07-26 19:34:54.000000000 +0200
+++ olsrd-current/make/Makefile.obsd	2007-08-29 23:46:25.000000000 +0200
@@ -21,6 +21,7 @@
 endif
 
 OS_LIB_PTHREAD =
+OS_CFLAG_PTHREAD =
 OS_LIB_DYNLOAD =
 
 # Local Variables:
